/*
 * Sixth 3D engine demos. Copyright ©2012-2016, Svjatoslav Agejenko, svjatoslav@svjatoslav.eu
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of version 3 of the GNU Lesser General Public License
 * or later as published by the Free Software Foundation.
 */

package eu.svjatoslav.sixth.e3d.examples.launcher;

import eu.svjatoslav.sixth.e3d.examples.*;

import javax.swing.*;
import java.awt.event.ActionEvent;
import java.io.IOException;

class MenuPanel extends JPanel {
    private static final long serialVersionUID = 2012721856427052560L;

    public MenuPanel() {

        final GroupLayout groupLayout = new GroupLayout(this);
        GroupLayout.SequentialGroup sequentialGroup = groupLayout.createSequentialGroup();
        sequentialGroup.addComponent(new JLabel("Choose an example to launch:"));
        sequentialGroup.addComponent(new JButton(new ShowOctree()));
        sequentialGroup.addComponent(new JButton(new ShowMathGraphs()));
        sequentialGroup.addComponent(new JButton(new ShowPointcloud()));
        sequentialGroup.addComponent(new JButton(new ShowRain()));
        sequentialGroup.addComponent(new JButton(new ShowSinusMap()));
        sequentialGroup.addComponent(new JButton(new ShowTextEditors()));
        sequentialGroup.addComponent(new JButton(new ShowGameOfLife()));
    }

    private class ShowTextEditors extends AbstractAction {
        public ShowTextEditors() {
            putValue(NAME, "Text editors");
        }

        @Override
        public void actionPerformed(final ActionEvent e) {
            TextEditorDemo.main(null);
        }
    }

    private class ShowSinusMap extends AbstractAction {
        public ShowSinusMap() {
            putValue(NAME, "Wireframe sphere and ploygon landscape");
        }

        @Override
        public void actionPerformed(final ActionEvent e) {
            SphereDemo.main(null);
        }
    }

    private class ShowRain extends AbstractAction {
        public ShowRain() {
            putValue(NAME, "Raining numbers");
        }

        @Override
        public void actionPerformed(final ActionEvent e) {
            try {
                RainingNumbersDemo.main(null);
            } catch (final IOException e1) {
                e1.printStackTrace();
            }
        }
    }

    private class ShowPointcloud extends AbstractAction {
        public ShowPointcloud() {
            putValue(NAME, "Pointcloud galaxy");
        }

        @Override
        public void actionPerformed(final ActionEvent e) {
            PointCloudDemo.main(null);
        }
    }

    private class ShowMathGraphs extends AbstractAction {
        public ShowMathGraphs() {
            putValue(NAME, "Mathematical graphs");
        }

        @Override
        public void actionPerformed(final ActionEvent e) {
            try {
                GraphDemo.main(null);
            } catch (final IOException e1) {
                e1.printStackTrace();
            }
        }
    }

    private class ShowOctree extends AbstractAction {
        public ShowOctree() {
            putValue(NAME, "Volumetric Octree");
        }

        @Override
        public void actionPerformed(final ActionEvent e) {
            try {
                OctreeDemo.main(null);
            } catch (final IOException e1) {
                e1.printStackTrace();
            }
        }
    }

    private class ShowGameOfLife extends AbstractAction {
        public ShowGameOfLife() {
            putValue(NAME, "Game of Life");
        }

        @Override
        public void actionPerformed(final ActionEvent e) {
            eu.svjatoslav.sixth.e3d.examples.life.Main.main(null);
        }
    }

}
